
Redmine - Defect #10416

Cannot Logout

2012-03-10 06:10 - Mom Cleomora

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:    

Resolution: Cant reproduce Affected version:  

Description

I've just upgraded to 1.3.1, everything works fine except I cannot Logging out.

It seems similar to #9840, #9118 but I could not solve with same solutions.

About my application's environment,

Ruby version              1.8.7 (i686-linux)

RubyGems version          1.4.2

Rack version              1.1

Rails version             2.3.14

Active Record version     2.3.14

Active Resource version   2.3.14

Action Mailer version     2.3.14

Active Support version    2.3.14

Application root          /home/jcit/rails_apps/redmine13

Environment               production

Database adapter          mysql

History

#1 - 2012-03-10 11:45 - Jean-Philippe Lang

except I cannot Logging out

 More details please.

#2 - 2012-03-11 07:23 - Mom Cleomora

Thank you so much for asking.

It still keeps me in logged-in status after I clicked on Sign out.

This means, once I Logged in there is no way to log out other than deleting browser's cookie manually.

http://doraemon.phsaez.com

ID/pass: guest/guest

Regards,

#3 - 2012-03-11 10:34 - Jean-Philippe Lang

- Resolution set to Cant reproduce

The Set-Cookie header is broken when I try to logout from http://doraemon.phsaez.com.

I get:

Set-Cookie: autologin=; path=/; expires=Thu, 01-Jan-1970 00:00:00 GMT_redmine_session=xxx--xxx; path=/; HttpOn

ly

 I should get:

Set-Cookie: autologin=; path=/; expires=Thu, 01-Jan-1970 00:00:00 GMT_

Set-Cookie: redmine_session=xxx--xxx; path=/; HttpOnly
 I found a similar issue reported here: http://rubyforge.org/pipermail/mongrel-unicorn/2011-June/001001.html

It doesn't seem to be a Redmine issue but a rack/http server issue.

#4 - 2012-03-12 07:57 - Mom Cleomora

I see. I am following the thread. It seems that newer version of rail does not handle multiple cookies correctly.

Now I've disabled the Autologin, I still cannot logout.

Is this also same cookie broken issue?

#5 - 2012-03-21 12:58 - Mom Cleomora

- Status changed from New to Resolved

temporarily solved with hard code work around.

#6 - 2012-04-24 09:41 - Dominik Fuchshofer

Could you please post the workaround?

#7 - 2012-04-24 12:23 - Mom Cleomora

First of all let me say I don't know about ruby.

What I did is, moved this line --> self.logged_user = nil in account_controller.rb to make sure it is called when user logout.

Redmine1.3.1/app/controllers/account_controller.rb (After modified)

  def logout_user

    self.logged_user = nil

    if User.current.logged?

      cookies.delete :autologin

      Token.delete_all(["user_id = ? AND action = ?", User.current.id, 'autologin'])

    end

  end

 Please look into this file, I guess it relates to the login/logout behavior.

#8 - 2014-08-15 17:52 - Jan Niggemann (redmine.org team member)

- Status changed from Resolved to Closed
